<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta name="theme-color" content="#000000" media="(prefers-color-scheme: dark)">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="description" content="✶✶✶">
        <title>DESTRUCT TV</title>
        <link rel="icon" href="favicon.svg">
        <link rel="mask-icon" color="#000" href="favicon.svg">
        <style>
            :root {
              --black: oklch(0% 0 0);
              --white: oklch(100% 0 0);
              --red: oklch(61% 0.38 14);
            }
            html{
                scrollbar-color: #0000 #0000;
            }
            body::-webkit-scrollbar{
                display: none;
            }
            html, body{
                margin: 0;
                padding: 0;
            }
            body{
                background-color: var(--black);
                color: var(--white);
                font-family: cq-mono;
                font-kerning: none;
                font-size: 1.8lvh;
                letter-spacing: 0.09em;
                line-height: 1.5em;
                text-transform: uppercase;
            }
            #center-wrapper{
                width: 100vw;
                height: 100vh;
                display: flex;
                align-items: center;
                justify-content: center;
                box-sizing: border-box;
                padding: 0;
                margin: 0;
            }
        </style>
    </head>
    <body>
        <script>
            window.dpr = window.devicePixelRatio;

            class CompBitrain extends HTMLElement{
                connectedCallback(){
                    const sr = this.attachShadow({mode: 'open'});
                    sr.innerHTML = `<canvas id="canvas" style="width: 100vw; height: 60vh;"></canvas>`;
                    const canvas = sr.getElementById("canvas");
                    const ctx = canvas.getContext("2d");
                    const particleCount = 5000;
                    let pointerActive = false;
                    let resizeTimeout = false;
                    let brightness = [];
                    let globalCount = 0;
                    let particles = [];
                    let hover = false;
                    let reset = false;
                    let pixels = [];
                    let cursor = {};
                    let pixelSize;
                    let width;

                    const img = new Image();
                    let images = ["./assets/bufferfly.webp", "./assets/bee.webp", "./assets/skull.webp"];
                    img.src = images[Math.floor(Math.random() * 3)];

                    class Particle {
                        constructor(){
                            this.x = Math.round(Math.random() * canvas.width / pixelSize) * pixelSize;
                            this.y = 0;
                            this.count = 0;
                            this.boost = Math.random() * 0.2;
                            this.velocity = canvas.height * (Math.random() * 0.004 + 0.004);
                        }
                        update(){
                            if(this.count == 8){
                                if(reset){
                                    this.count = 0;
                                    this.x = Math.round(Math.random() * canvas.width / pixelSize) * pixelSize;
                                    this.y = 0;
                                };
                                return;
                            };
                            this.y = Math.round(this.y + (this.velocity * (1 - pixels[(this.y * canvas.width) + this.x] * 0.9)) + 0.4);
                            if(this.y >= canvas.height){
                                this.count++
                                if(this.count == 8){
                                    globalCount += 1;
                                    this.y = 0;
                                }
                                else{
                                    this.x = Math.round(Math.random() * canvas.width / pixelSize) * pixelSize;
                                    this.y = 0
                                };
                            };
                        };
                        draw(){
                            let pixel = Math.min((pixels[(this.y * canvas.width) + this.x] + this.boost) * (brightness[this.y]), 1) * 100;
                            ctx.fillStyle = `oklch(${pixel}% 0 0)`;
                            let drawY = Math.round(this.y / pixelSize) * pixelSize;
                            ctx.fillRect(this.x, drawY, pixelSize, pixelSize);
                        };
                    };

                    function canvasConfig(){
                        width = window.innerWidth;
                        canvas.width = sr.getElementById("canvas").offsetWidth * dpr;
                        canvas.height = sr.getElementById("canvas").offsetHeight * dpr;
                        pixelSize = Math.round(canvas.height * 0.008);
                        particles = [];
                        for(let i = 0; i < particleCount; i++){
                            particles.push(new Particle);
                        };

                        ctx.drawImage(img, 0 + ((canvas.width - (canvas.height * (img.width / img.height))) / 2), 0, canvas.height * (img.width / img.height), canvas.height);
                        let imgData = ctx.getImageData( 0, 0, canvas.width, canvas.height);
                        pixels = [];
                        for(let i = 0; i < imgData.data.length; i += 4){
                            pixels.push(imgData.data[i]  / 255);
                        };

                        let gradient = ctx.createLinearGradient(0, canvas.height, 0, 0);
                        gradient.addColorStop(0, "#000");
                        gradient.addColorStop(0.35, "#fff");
                        gradient.addColorStop(0.65, "#fff");
                        gradient.addColorStop(1, "#000");
                        ctx.fillStyle = gradient;
                        ctx.fillRect(0, 0, canvas.width, canvas.height);
                        let gradientData = ctx.getImageData( 0, 0, 1, canvas.height);
                        brightness = [];
                        for(let i = 0; i < gradientData.data.length; i += 4){
                            brightness.push(gradientData.data[i] / 255);
                        };

                        ctx.clearRect(0, 0, canvas.width, canvas.height);
                    };

                    function draw(){
                        if(globalCount >= particleCount * 0.9){
                            reset = true;
                            globalCount = 0;
                        }
                        else if(reset){
                            reset = false;
                        };
                        ctx.fillStyle = "#0001";
                        ctx.fillRect(0, 0, canvas.width, canvas.height);
                        for(let i = 0; i < particleCount; i++){
                            particles[i].update();
                            particles[i].draw();
                        };
                    };

                    function animate(){
                        if(resizeTimeout){return};
                        draw();
                        requestAnimationFrame(animate);
                    };

                    img.addEventListener("load", () => {
                        canvasConfig();
                        animate();
                    });
                };
            };

            window.customElements.define("comp-bitrain", CompBitrain);
        </script>

        <div id="center-wrapper">
            <comp-bitrain img="/assets/bee.webp"></comp-bitrain>
        </div>

    </body>
</html>
